using System;
using System.Collections.Generic;
using System.Data;
using ReactiveUI;
using System.Linq;
using AvaloniaApplication5.Models;
using Microsoft.EntityFrameworkCore;
using MsBox.Avalonia.Enums;
using MsBox.Avalonia;

namespace AvaloniaApplication5.ViewModels
{
    internal class ShowViewModel : ViewModelBase
    {
        public List<Teacher> TeacherList => MainWindowViewModel.myConnection.Teachers.
                                                                       Include(x => x.Gender).
                                                                       Include(x => x.TeacherDisciplines).ThenInclude(x => x.Discipline).
                                                                      Include(x => x.TeacherCourses).ThenInclude(x => x.Course).
            ToList();
        public void ToAddPage()
        {
            MainWindowViewModel.Instance.PageContent = new AddPage();
        }

        public async void DeleteTeacher(int idt)
        {
            //   
            ButtonResult result = await MessageBoxManager.GetMessageBoxStandard(" ",
                "  ?", ButtonEnum.YesNo).ShowAsync();

            if (result == ButtonResult.Yes)
            {
                //   ,  
                Teacher deleteTeacher = MainWindowViewModel.myConnection.Teachers.First(x => x.Id == idt);
                MainWindowViewModel.myConnection.Teachers.Remove(deleteTeacher);
                MainWindowViewModel.myConnection.SaveChanges();
                await MessageBoxManager.GetMessageBoxStandard("", " ", ButtonEnum.Ok).ShowAsync();
                MainWindowViewModel.Instance.PageContent = new Show();
            }
            else
            {
                //   , , ,  
                await MessageBoxManager.GetMessageBoxStandard("", " .", ButtonEnum.Ok).ShowAsync();
            }
        }

        string _message = "";

        public string Message
        {
            get => _message;
            set => this.RaiseAndSetIfChanged(ref _message, value);
        }

        public void UpdateTeacher(int idt)
        {
            MainWindowViewModel.Instance.PageContent = new AddPage(idt);
        }
    }  
}